接上文。
cd /usr/local/srcwget http://downloads.sourceforge.net/project/pcre/pcre/8.34/pcre-8.34.tar.gz
tar zxvf pcre-8.34.tar.gzcd pcre-8.34./configure --prefix=/usr/local/pcremakemake install
cd /usr/local/srcwget http://labs.frickle.com/files/ngx_cache_purge-2.1.tar.gz
tar zxvf ngx_cache_purge-2.1.tar.gz
yum install openssl openssl-devel -y
cd /usr/local/srcwget http://tengine.taobao.org/download/tengine-2.0.0.tar.gztar zxvf tengine-2.0.0.tar.gzcd tengine-2.0.0./configure --add-module=/usr/local/src/ngx_cache_purge-2.1 --prefix=/usr/local/nginx --with-http_stub_status_module --with-pcre=/usr/local/src/pcre-8.34
make
make install
/usr/local/nginx/sbin/nginx #啟動(dòng)nginxchown nobody.nobody -R /usr/local/nginx/htmlchmod 700 -R /usr/local/nginx/html
如果編譯的問題的話,看看是不是下面的原因:
./configure: error: the HTTP SSL module requires OpenSSL library 原因:安裝http_ssl_module模塊需要openssl library 解決:yum install openssl-devel./configure: error: the HTTP rewrite module requires the PCRE library. 原因:安裝http_rewrite_module模塊需要先安裝PCRE開發(fā)包 解決:yum install pcre-devel
注意:
--with-pcre=/usr/local/src/pcre-8.21指向的是源碼包解壓的路徑,而不是安裝的路徑,否則會(huì)報(bào)錯(cuò)。
--add-module=/usr/local/src/ngx_cache_purge-2.1 是指加載緩存的插件模塊
vi /etc/rc.d/init.d/nginx #編輯啟動(dòng)文件添加下面內(nèi)容
#!/bin/bash# Tengine Startup script# processname: nginx# chkconfig: - 85 15# description: nginx is a World Wide Web server. It is used to serve# pidfile: /var/run/nginx.pid# config: /usr/local/nginx/conf/nginx.confnginxd=/usr/local/nginx/sbin/nginxnginx_config=/usr/local/nginx/conf/nginx.confnginx_pid=/usr/local/nginx/logs/nginx.pidRETVAL=0prog="nginx"# Source function library.. /etc/rc.d/init.d/functions# Source networking configuration.. /etc/sysconfig/network# Check that networking is up.[ ${NETWORKING} = "no" ] && exit 0[ -x $nginxd ] || exit 0# Start nginx daemons functions.start() {if [ -e $nginx_pid ];thenecho "tengine already running...."exit 1fiecho -n $"Starting $prog: "daemon $nginxd -c ${nginx_config}RETVAL=$?echo[ $RETVAL = 0 ] && touch /var/lock/subsys/nginxreturn $RETVAL}# Stop nginx daemons functions.stop() {echo -n $"Stopping $prog: "killproc $nginxdRETVAL=$?echo[ $RETVAL = 0 ] && rm -f /var/lock/subsys/nginx /usr/local/nginx/logs/nginx.pid}reload() {echo -n $"Reloading $prog: "#kill -HUP `cat ${nginx_pid}`killproc $nginxd -HUPRETVAL=$?echo}# See how we were called.case "$1" instart)start;;stop)stop;;reload)reload;;restart)stopstart;;status)status $progRETVAL=$?;;*)echo $"Usage: $prog {start|stop|restart|reload|status|help}"exit 1esacexit $RETVAL
保存退出
chmod 775 /etc/rc.d/init.d/nginx #賦予文件執(zhí)行權(quán)限chkconfig --level 012345 nginx on #設(shè)置開機(jī)啟動(dòng)/etc/rc.d/init.d/nginx restart
四、配置Tengine
將nginx初始配置文件備份,我們要重新創(chuàng)建配置文件.
mv /usr/local/nginx/conf/nginx.conf /usr/local/nginx/conf/nginx.conf.bak
創(chuàng)建nginx用戶www
groupadd www
useradd -g www www
編輯主配置文件:
vi /usr/local/nginx/conf/nginx.conf
內(nèi)容如下:
user www www; worker_processes 4; # 工作進(jìn)程數(shù),為CPU的核心數(shù)或者兩倍 error_log logs/error.log crit; # debug|info|notice|warn|error|crit pid logs/nginx.pid;
#Specifies the value for maximum file descriptors that can be opened by this process.
worker_rlimit_nofile 65535;
events { use epoll; #Linux最常用支持大并發(fā)的事件觸發(fā)機(jī)制 worker_connections 65535; } http { include mime.types; #設(shè)定mime類型,類型由mime.type文件定義 default_type application/octet-stream;
charset utf-8;
log_format main '$remote_addr - $remote_user [$time_local] "$request" ' '$status $body_bytes_sent "$http_referer" ' '"$http_user_agent" "$http_x_forwarded_for"'; access_log logs/access.log main; #設(shè)定請(qǐng)求緩沖 server_names_hash_bucket_size 256; #增加,原為128 client_header_buffer_size 256k; #增加,原為32k large_client_header_buffers 4 256k; #增加,原為32k #size limits client_max_body_size 50m; #允許客戶端請(qǐng)求的最大的單個(gè)文件字節(jié)數(shù) client_header_timeout 3m; client_body_timeout 3m; send_timeout 3m; sendfile on; tcp_nopush on; keepalive_timeout 60; tcp_nodelay on; server_tokens on; #不顯示nginx版本信息 limit_conn_zone $binary_remote_addr zone=perip:10m; #添加limit_zone,限制同一IP并發(fā)數(shù) #fastcgi_intercept_errors on; #開啟錯(cuò)誤頁面跳轉(zhuǎn) include gzip.conf; #壓縮配置文件 include proxy.conf; #proxy_cache參數(shù)配置文件 include vhost/*.conf; #nginx虛擬主機(jī)包含文件目錄 include mysvrhost.conf; #后端WEB服務(wù)器列表文件}
編輯代理配置文件:
cd /usr/local/nginx/conf/mkdir vhostvi /usr/local/nginx/conf/proxy.conf
內(nèi)容如下:
#注:proxy_temp_path和proxy_cache_path指定的路徑必須在同一分區(qū)
proxy_temp_path /tmp/proxy_temp;
#設(shè)置Web緩存區(qū)名稱為cache_one,內(nèi)存緩存空間大小為500MB,1天沒有被訪問的內(nèi)容自動(dòng)清除,硬盤緩存空間大小為30GB。proxy_cache_path /tmp/proxy_cache levels=1:2 keys_zone=cache_one:500m inactive=1d max_size=30g;
client_body_buffer_size 512k; #原為512k proxy_connect_timeout 50; #代理連接超時(shí) proxy_read_timeout 600; #代理發(fā)送超時(shí) proxy_send_timeout 600; #代理接收超時(shí) proxy_buffer_size 128k; #代理緩沖大小,原為32k proxy_buffers 16 256k; #代理緩沖,原為4 64k proxy_busy_buffers_size 512k; #高負(fù)荷下緩沖大小,原為128k proxy_temp_file_write_size 1024m; #proxy緩存臨時(shí)文件的大小原為128k #proxy_ignore_client_abort on; #不允許代理端主動(dòng)關(guān)閉連接 proxy_next_upstream error timeout invalid_header http_500 http_503 http_404 http_502 http_504;
編輯主機(jī)配置文件:
vi /usr/local/nginx/conf/mysvrhost.conf
內(nèi)容如下:
upstream cn100 { ip_hash; #會(huì)話保持 server 127.0.0.1:8080 max_fails=1 fail_timeout=60s; server 127.0.0.1:9080 max_fails=1 fail_timeout=60s;}
編輯壓縮配置文件:
vi /usr/local/nginx/conf/gzip.conf
內(nèi)容如下:
#網(wǎng)頁GZIP壓縮設(shè)置 #2012.4.2 #可通過http://tool.chinaz.com/Gzips/檢測(cè)壓縮情況 # #啟動(dòng)預(yù)壓縮功能,對(duì)所有類型的文件都有效 #gzip_static on; #開啟nginx_static后,對(duì)于任何文件都會(huì)先查找是否有對(duì)應(yīng)的gz文件 #找不到預(yù)壓縮文件,進(jìn)行動(dòng)態(tài)壓縮 gzip on; gzip_min_length 1k; #設(shè)置最小的壓縮值,單位為bytes.超過設(shè)置的min_length的值會(huì)進(jìn)行壓縮,小于的不壓縮. gzip_comp_level 3; #壓縮等級(jí)設(shè)置,1-9,1是最小壓縮,速度也是最快的;9剛好相反,最大的壓縮,速度是最慢的,消耗的CPU資源也多 gzip_buffers 16 64k; #設(shè)置系統(tǒng)的緩存大小,以存儲(chǔ)GZIP壓縮結(jié)果的數(shù)據(jù)流,它可以避免nginx頻煩向系統(tǒng)申請(qǐng)壓縮空間大小 gzip_types text/plain application/x-javascript text/css text/javascript; #關(guān)于gzip_types,如果你想讓圖片也開啟gzip壓縮,那么用以下這段吧: #gzip_types text/plain application/x-javascript text/css text/javascript application/x-httpd-php image/jpeg image/gif image/png; #gzip公共配置 gzip_http_version 1.1; #識(shí)別http的協(xié)議版本(1.0/1.1) gzip_proxied any; #設(shè)置使用代理時(shí)是否進(jìn)行壓縮,默認(rèn)是off的 gzip_vary on; #和http頭有關(guān)系,加個(gè)vary頭,代理判斷是否需要壓縮 gzip_disable "MSIE [1-6]."; #禁用IE6的gzip壓縮
編輯配置文件:
vi /usr/local/nginx/conf/vhost/cn100.conf
內(nèi)容如下:
server {
listen 80;
server_name localhost;
#默認(rèn)啟動(dòng)文件
index index.html index.htm;
#配置發(fā)布目錄為/usr/local/tomcat1/webapps/ROOT
root /usr/local/tomcat1/webapps/ROOT;
location /
{
#如果后端的服務(wù)器返回502、504、執(zhí)行超時(shí)等錯(cuò)誤,自動(dòng)將請(qǐng)求轉(zhuǎn)發(fā)到upstream負(fù)載均衡池中的另一臺(tái)服務(wù)器,實(shí)現(xiàn)故障轉(zhuǎn)移。
proxy_next_upstream http_502 http_504 error timeout invalid_header;
proxy_cache cache_one;
#對(duì)不同的HTTP狀態(tài)碼設(shè)置不同的緩存時(shí)間
proxy_cache_valid 200 304 12h;
#以域名、URI、參數(shù)組合成Web緩存的Key值,Nginx根據(jù)Key值哈希,存儲(chǔ)緩存內(nèi)容到二級(jí)緩存目錄內(nèi)
proxy_cache_key $host$uri$is_args$args;
proxy_set_header Host $host;
proxy_set_header X-Real-IP $remote_addr;
proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
proxy_pass http://cn100;
proxy_pass_header Set-Cookie;
#對(duì)用戶傳輸Set-Cookie的http頭,不然無法支持一些包含cookie的應(yīng)用,比如我的typecho
#過期時(shí)間3天
expires 3d;
}
#用于清除緩存,假設(shè)一個(gè)URL為http://192.168.8.42/test.txt,通過訪問http://192.168.8.42/purge/test.txt就可以清除該URL的緩存。
location ~ /purge(/.*)
{
#設(shè)置只允許指定的IP或IP段才可以清除URL緩存。
allow 127.0.0.1;
allow 192.168.0.0/16;
deny all;
proxy_cache_purge cache_one $host$1$is_args$args;
}
# 查看nginx的并發(fā)連接數(shù)配置
location /NginxStatus
{
stub_status on;
access_log off;
auth_basic "NginxStatus";
}
#定義Nginx輸出日志的路徑
#access_log /data/logs/nginx_wugk/access.log main;
#error_log /data/logs/nginx_wugk/error.log crit;
#access_log off; #根據(jù)自己的需要選擇是否啟用access日志,注釋掉代表啟用
error_page 404 /404.html;
error_page 500 502 503 504 /404.html;
location = /404.html {
root html;
}
limit_conn perip 50; #同一ip并發(fā)數(shù)為50,超過會(huì)返回503
}
為Tengine配置一下系統(tǒng)的TCP設(shè)置,優(yōu)化一下:
vi /etc/sysctl.conf
內(nèi)容如下:
net.ipv4.ip_forward = 0 net.ipv4.conf.default.rp_filter = 1 net.ipv4.conf.default.accept_source_route = 0 kernel.sysrq = 0 kernel.core_uses_pid = 1 net.ipv4.tcp_syncookies = 1 kernel.msgmnb = 65536 kernel.msgmax = 65536 kernel.shmmax = 68719476736 kernel.shmall = 4294967296 net.ipv4.tcp_max_tw_buckets = 6000 net.ipv4.tcp_sack = 1 net.ipv4.tcp_window_scaling = 1 net.ipv4.tcp_rmem = 4096 87380 4194304 net.ipv4.tcp_wmem = 4096 16384 4194304 net.core.wmem_default = 8388608 net.core.rmem_default = 8388608 net.core.rmem_max = 16777216 net.core.wmem_max = 16777216 net.core.netdev_max_backlog = 262144 net.core.somaxconn = 262144 net.ipv4.tcp_max_orphans = 3276800 net.ipv4.tcp_max_syn_backlog = 262144 net.ipv4.tcp_timestamps = 0 net.ipv4.tcp_synack_retries = 1 net.ipv4.tcp_syn_retries = 1 net.ipv4.tcp_tw_recycle = 1 net.ipv4.tcp_tw_reuse = 1 net.ipv4.tcp_mem = 94500000 915000000 927000000 net.ipv4.tcp_fin_timeout = 1 net.ipv4.tcp_keepalive_time = 30 net.ipv4.ip_local_port_range = 1024 65000 #允許系統(tǒng)打開的端口范圍
使配置立即生效
/sbin/sysctl -p
制作一個(gè)重啟全部的腳本
vi /root/restartall
#!/bin/sh##重啟memcached進(jìn)程service memcached restart#清空日志rm -f /usr/local/tomcat1/logs/*rm -f /usr/local/tomcat2/logs/*
#清空緩存
rm -rf /tmp/proxy_cache #重啟動(dòng)tomcat/usr/local/tomcat1/bin/shutdown.sh
/usr/local/tomcat2/bin/shutdown.sh
/usr/local/tomcat1/bin/startup.sh
/usr/local/tomcat2/bin/startup.sh
#重啟nginx
service nginx restart
給運(yùn)行權(quán)限
chmod 777 /root/restartall
以后重啟服務(wù)只需要:
/root/restartall
聯(lián)系客服